<?php

namespace Factory;

use \Teknisa\Model\Teknisa\Entities;

class Call {

    function createProductCall($reference, $reportedBy, $description,  $type, $callRelationship, $product, $classification = null){
        $entity = new  Entities\CpCall();
        $entity->setReference($reference);
        if(!$reportedBy){
            $reportedBy = 1;
        }
        $entity->setReportedBy($reportedBy);
        if(!$description){
            $description = ' ';
        }
        $entity->setDescription($description);
        $entity->setType($type);
        $entity->setCallRelationship($callRelationship);
        $entity->setProduct($product);
        $entity->setClassification($classification);
        return $entity;
    }

    public function createSupportCall($reference, $reportedBy, $description, $type, $callRelationship, $product, $cause) {
        $entity = new  Entities\CpCall();
        $entity->setReference($reference);
        $entity->setReportedBy($reportedBy);
        $entity->setDescription($description);
        $entity->setType($type);
        $entity->setCallRelationship($callRelationship);
        $entity->setProduct($product);
        $entity->setCause($cause);
        return $entity;
    }

    public function updateSupportCall(Entities\CpCall $entity, $reference, $description, $product, $cause) {
        $entity->setReference($reference);
        $entity->setDescription($description);
        $entity->setProduct($product);
        $entity->setCause($cause);
        return $entity;
    }

    function createCall($reference, $product, $classification, $description, $reportedBy, $type, $callRelationship){
        $entity = new  Entities\CpCall();
        $entity->setReference($reference);
        $entity->setProduct($product);
        $entity->setClassification($classification);
        $entity->setDescription($description);
        $entity->setReportedBy($reportedBy);
        $entity->setType($type);
        $entity->setCallRelationship($callRelationship);
        return $entity;
    }

    public function updateCall(Entities\CpCall $call, $reference, $product, $classification, $description) {
        $call->setReference($reference);
        $call->setProduct($product);
        $call->setClassification($classification);
        $call->setDescription($description);
        return $call;
    }

    public function updateCallAddInvisibleFields(Entities\CpCall $call, $invisibleFields) {
        $call->setTextSmall1($invisibleFields["TEXT_SMALL_1"]);
        $call->setTextSmall2($invisibleFields["TEXT_SMALL_2"]);
        $call->setTextSmall3($invisibleFields["TEXT_SMALL_3"]);
        $call->setTextSmall4($invisibleFields["TEXT_SMALL_4"]);
        $call->setTextSmall5($invisibleFields["TEXT_SMALL_5"]);
        $call->setTextLong1($invisibleFields["TEXT_LONG_1"]);
        $call->setTextLong2($invisibleFields["TEXT_LONG_2"]);
        $call->setTextLong3($invisibleFields["TEXT_LONG_3"]);
        $call->setTextLong4($invisibleFields["TEXT_LONG_4"]);
        $call->setTextLong5($invisibleFields["TEXT_LONG_5"]);
        $call->setDate1($invisibleFields["DATE_1"]);
        $call->setDate2($invisibleFields["DATE_2"]);
        $call->setDate3($invisibleFields["DATE_3"]);
        $call->setDate4($invisibleFields["DATE_4"]);
        $call->setDate5($invisibleFields["DATE_5"]);
        $call->setNumber1($invisibleFields["NUMBER_1"]);
        $call->setNumber2($invisibleFields["NUMBER_2"]);
        $call->setNumber3($invisibleFields["NUMBER_3"]);
        $call->setNumber4($invisibleFields["NUMBER_4"]);
        $call->setNumber5($invisibleFields["NUMBER_5"]);
        return $call;
    }
} 